Title: Defending availability
Date: 2019-04-16 00:00
Category: News
Slug: defending-availability
Lang: en

![Altai's Katun river][screenshot]

In this article, we describe the beginning of our efforts to protect ourselves from third-party solutions.

Since day one of Opensource Game Studio project, we rely heavily on third-party solutions to help us achieve the goal of creating the best game development tools. To this date, we used forums, task trackers, mailing lists, social networks, code version control systems, hosting providers, compiler suites, libraries, and so on. Each third-party solution we used had its own lifespan.

There are two main reasons why we changed third-party solutions:

* Change in our needs
* Solution shutdown

The shutdown of [Google Code][google-code] in 2016 was the first time we experienced the deadly business hand. We were using SVN, Mercurial, and Google issue tracker. We were forced to let all of them go.

We transferred our source code into both [BitBucket][bitbucket] and [GitHub][github] because we didn't want to put all eggs into one basket. We became wiser thanks to Google Code shutdown experience.

Issue tracking had a different fate. At first, we used Bugzilla to manager our issues. However, Bugzilla was so inconvenient that we dropped it in favor of Google Sheets. To this date, we use Google Sheets to plan and log our work on the project. We also use Google Docs to write this very news and review it before publishing.

The shutdown of [goo.gl][goo-gl] (URL shortener) in 2019 was the second time we experienced that same deadly business hand. We were using goo.gl to shorten Google Docs URLs internally. Not really big damage was done, however, this only proved that third-party solutions are not ours, but theirs.

Microsoft [acquired GitHub][github-acquisition] in 2018. So far (April 2019) Microsoft is doing a really good job by empowering GitHub with the [release of GitPod][gitpod] to allow developers to build GitHub projects in a single click. However, Microsoft is also known for shutting down [Codeplex][codeplex] in 2017.

This short track of shutdowns and acquisitions in the course of the past four years highlights the business' main objective: making profits. Personally, we have no problem with that objective. It's really hard to live in the 21st century without earning money. We are no exception to this, we pay bills, too. However, a much more humane option would be to let the source code go into the wild, to let interested developers continue the development of those solutions if they want to. Though, this would lead to even more competition with the business itself, something the business tries to avoid at all costs.

We are no business, we make no profits off our tools. Our goals are only to create tools and let them go into the wild, so you can use them. Currently, we use GitHub to host some of our [tutorials][tutorials] and [guides][guides]. Now imagine that two years from now Microsoft decides to decommission GitHub. Why? Maybe because [people gradually migrate][migration] from GitHub to GitLab.

How are we to protect ourselves from the deadly business hand? We consolidate our tools, tutorials, and games into this very site. The first step, now complete, was to create a static site generator to generate this very site.

So far the generated site has the following functionality:

* news that span multiple pages
* standalone pages
* sitewide language selection

We will make the site even more convenient during this year. Stay tuned!

That's it for describing the beginning of our efforts to protect ourselves from third-party solutions.


[screenshot]: ../../images/2019-04-16_defending-availability.jpg
[google-code]: https://code.google.com/archive/
[bitbucket]: https://bitbucket.org/ogstudio/
[github]: https://github.com/ogstudio/
[goo-gl]: https://developers.googleblog.com/2018/03/transitioning-google-url-shortener.html
[github-acquisition]: https://github.blog/2018-10-26-github-and-microsoft/
[gitpod]: https://www.gitpod.io/blog/gitpod-launch/
[codeplex]: https://devblogs.microsoft.com/bharry/shutting-down-codeplex/
[tutorials]: https://github.com/OGStudio/openscenegraph-cross-platform-examples
[guides]: https://github.com/OGStudio/openscenegraph-cross-platform-guide
[migration]: https://hackernoon.com/git-wars-why-im-switching-to-gitlab-e471f5e8be2c
